﻿/* 
	类:Lix Tabs
	版本:0.2
	作者:十年灯 http://www.cnblogs.com/lixlib/
	说明:欢迎使用,欢迎转载,但请勿据为已有
	
 */	
	var $id=function(id){
		return (typeof id == "Object") ? id : document.getElementById(id);
	};
	var $$=function(tag,elm){
		return elm.getElementsByTagName(tag);
	};
	var $C=function(cn,tag,elm){
		if(!tag) tag='*';
		var ts = $$(tag,elm);
		var classArr = [];
		var filter = new RegExp("(^|\\s)"+cn+"(\\s|$)");
		for(var i=0,l=ts.length;i<l;i++){
			if(filter.test(ts[i].className)){
				classArr.push(ts[i]);
			}
		}
		return classArr;
	}
	var cutover=function(arr,cur,c1,c0){
		for(var i=0,l=arr.length;i<l;i++){
			arr[i].className = (i ==cur) ? c1 : c0;
		}
	}
	var Bind = function(object, fun) {
		return function() {
			return fun.apply(object);
		}
	}
	var Tabs = function (elm,items){
		if(elm == null){return false;}
		var t=this;
		var a=items;
		
		/*开始缓存传入参数*/
		t.hdtag =a.hdtag || 'DIV';
		t.hdcn =a.hdcn || 'tabhd';
		t.hdtagcur =a.hdtagcur || 'cur';
		t.hdtagno =a.hdtagno || '';
		t.bdtag =a.bdtag || 'DIV';
		t.bdcn =a.bdcn || 'tabbd';
		t.bdtagcur =a.bdtagcur || 'cur';
		t.bdtagno =a.bdtagno || '';
		/*缓存参数完成*/
		
		t.tabhd = $C(t.hdcn,t.hdtag,elm)[0];
		t.tabtag = t.tabhd.children;
		t.tabbd = $C(t.bdcn,t.bdtag,elm)[0];
		t.tabcon = t.tabbd.children;
		
		t.now = 0;
		t.yes = true;
		t.time =a.auto;
		t.sum = t.tabtag.length;
		if(t.sum != t.tabcon.length) {
			alert('Tab标签个数与内容个数不匹配');
			return true;
		}
		/**/
		for(var i=0;i<t.sum;i++){
			t.tabtag[i].to = i;
			t.tabtag[i].onmouseover = function(){
				t.now = this.to;
				t.yes = false;
				this.run = setTimeout(Bind(t,t.change),300);
			}
			t.tabtag[i].onmouseout = function(){
				t.yes = true;
				clearTimeout(this.run);
			}
		}
		this.change();
		if(t.time){
			elm.onmouseover = function(){
				t.stop()
			}
			elm.onmouseout = function(){
				t.go()
			}
			
		}
	}
	Tabs.prototype = {
		change:function(){
			cutover(this.tabtag,this.now,this.hdtagcur,this.hdtagno);
			cutover(this.tabcon,this.now,this.bdtagcur,this.bdtagno);
			if(this.time && this.yes){
				this.now = (this.now == this.sum-1) ? 0 : this.now+1;
				this.go();
			}
		},
		go:function(){
			this.stop();
			this.auto = setTimeout(Bind(this,this.change),this.time)
		},
		stop:function(){
			clearTimeout(this.auto);
		}
	};
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	